import { ApiProperty } from '@nestjs/swagger';
import { Column, Entity, OneToMany, PrimaryGeneratedColumn } from 'typeorm';
import { Group } from './group.entity';

@Entity('zones')
export class Zone {
  // ----------------------------------------
  @ApiProperty({
    type: Number,
    name: 'id',
    description: 'id of zone, auto-incremented',
    required: true,
  })
  @PrimaryGeneratedColumn('increment')
  id: number;

  // ----------------------------------------
  @ApiProperty({
    type: String,
    name: 'name',
    description: 'Zone name',
    required: true,
  })
  @Column({
    type: 'varchar',
  })
  name: string;

  // ----------------------------------------
  @ApiProperty({
    type: Number,
    name: 'displayOrder',
    description: 'Display order',
    required: false,
  })
  @Column({
    type: 'tinyint',
    default: 0,
  })
  displayOrder: number;

  // ----------------------------------------
  @ApiProperty({
    name: 'groups',
    description: 'Children: groups',
    type: () => [Group],
  })
  // @ApiPropertyOptional()
  @OneToMany(() => Group, (group) => group.zone)
  groups: Group[];
}
